<?php
namespace homework\test_composer;

use seekquarry\yioop\library\PhraseParser;
use seekquarry\yioop\library\FetchUrl;
use seekquarry\yioop\library\CrawlConstants;
use seekquarry\yioop\library\processors\HtmlProcessor;


require_once "vendor/autoload.php";
define("seekquarry\\yioop\\configs\\PROFILE", true);

//check if file exists
if (file_exists($argv[1])){

}
else{
  exit("The file does not exist \n");
}

//open the text file with urls and read them line by line and store in 2-d $url_array
//line_number corresponds to docid and url is the url
$file = fopen($argv[1], "r");
$url_array = array(array());
$line_number = 0;
while(!feof($file))
{
   $line = fgets($file);
   $url_array[$line_number][CrawlConstants::URL] = trim($line);
   $line_number = $line_number + 1;
}
//removing last element of array as it is empty
array_pop($url_array);
//close file
fclose($file);


//download the urls
$page_data = FetchUrl::getPages($url_array);


//instantiate objects
$htmlProcessor = new HtmlProcessor([], 20000, CrawlConstants::CENTROID_WEIGHTED_SUMMARIZER);
$parser = new PhraseParser();

//create inverted index array of form term => (docList, freq, postingList)
$inverted_index = array();
for ($docId = 0; $docId < $line_number-1; $docId++) {

//text extraction from html documents
    $htmlProcessInfo = $htmlProcessor->process($page_data[$docId][CrawlConstants::PAGE], $url_array[$docId][CrawlConstants::URL]);
    $text = $htmlProcessInfo[CrawlConstants::DESCRIPTION];


//split the document into terms
    $text_string = preg_replace("/[^a-zA-Z 0-9]+/", " ", $text);

//change to lower case
    $text_lower_case = strtolower($text_string);
    $terms = array();


//if neither stem nor char
if(empty($argv[2]))
{
  $terms = explode(" ", $text_lower_case);
}
//stem the terms if option given
elseif($argv[2] == "stem") {
    $terms = PhraseParser::stemTerms($text_lower_case, $htmlProcessInfo[CrawlConstants::LANG]);
}
//char the terms if option given
elseif($argv[2] == "char") {
    $text_lower_case=explode(" ",$text_lower_case);
    $terms = PhraseParser::getNGramsTerm($text_lower_case, 4);
}


$index = 0;
for ($pos = 0; $pos < sizeof($terms); $pos++) {
   if($terms[$pos] == '') {continue;}


  $index++;
  if (array_key_exists($terms[$pos], $inverted_index)) {
     $inverted_index[$terms[$pos]]["freq"] = $inverted_index[$terms[$pos]]["freq"] + 1;
     array_push($inverted_index[$terms[$pos]]["postingList"],[$docId+1,$index]);
}
else {
    $inverted_index[$terms[$pos]] = array();
    $inverted_index[$terms[$pos]]["freq"] = 1;
    $inverted_index[$terms[$pos]]["postingList"] = array();
    $inverted_index[$terms[$pos]]["postingList"][0] = [$docId+1,$index];
}
}
}

//sort and print the inverted index
ksort($inverted_index);
foreach ($inverted_index as $key => $value) {
     echo $key;
     echo "\n";
     $temp=0;
     $count=0;
foreach($inverted_index[$key]["postingList"] as $posting){
     if(($temp)==$posting[0]){
          continue;
}
else{
    $temp=$posting[0];
    $count=$count+1;
}

}
$docCount=$count;

echo $docCount;
echo ",";
echo $inverted_index[$key]["freq"];
foreach($inverted_index[$key]["postingList"] as $posting) {
     echo "," . "(" . $posting[0] . "," . $posting[1] . ")";
}
echo "\n";
}
